Package org.apache.ignite.events

## Class ClusterStateChangeStartedEvent

- java.lang.Object
- - org.apache.ignite.events.EventAdapter
  - - org.apache.ignite.events.ClusterStateChangeStartedEvent

- All Implemented Interfaces:
    `Serializable`, `Comparable<Event>`, `Event`

      public class ClusterStateChangeStartedEvent
      extends EventAdapter

  Cluster state change started event.

  Grid events are used for notification about what happens within the grid. Note that by design Ignite keeps all events generated on the local node locally and it provides APIs for performing a distributed queries across multiple nodes:

  - `IgniteEvents.remoteQuery(IgnitePredicate, long, int...)` - asynchronously querying events occurred on the nodes specified, including remote nodes.
  - `IgniteEvents.localQuery(IgnitePredicate, int...)` - querying only local events stored on this local node.
  - `IgniteEvents.localListen(IgnitePredicate, int...)` - listening to local grid events (events from remote nodes not included).
  User can also wait for events using method `IgniteEvents.waitForLocal(IgnitePredicate, int...)`.

  # Events and Performance

  Note that by default all events in Ignite are enabled and therefore generated and stored by whatever event storage SPI is configured. Ignite can and often does generate thousands events per seconds under the load and therefore it creates a significant additional load on the system. If these events are not needed by the application this load is unnecessary and leads to significant performance degradation.

  It is highly recommended to enable only those events that your application logic requires by using `IgniteConfiguration.getIncludeEventTypes()` method in Ignite configuration. Note that certain events are required for Ignite's internal operations and such events will still be generated but not stored by event storage SPI if they are disabled in Ignite configuration.

  See Also:
    `EventType.EVT_CLUSTER_STATE_CHANGE_STARTED`, Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ClusterStateChangeStartedEvent​(ClusterState prevState, ClusterState state, ClusterNode node, String msg, UUID subjId)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `ClusterState` | `previousState()` |
    `ClusterState` | `state()` |
    `@Nullable UUID` | `subjectId()` | Gets security subject ID initiated state change.

    - ### Methods inherited from class org.apache.ignite.events.EventAdapter

      `compareTo, equals, hashCode, id, localOrder, message, message, name, node, node, shortDisplay, timestamp, toString, type, type`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ClusterStateChangeStartedEvent

          public ClusterStateChangeStartedEvent​(ClusterState prevState,
                                                ClusterState state,
                                                ClusterNode node,
                                                String msg,
                                                UUID subjId)

      Parameters:
        `prevState` - Previous cluster state.
        `state` - New cluster state.
        `node` - Node.
        `msg` - Optional event message.
        `subjId` - Subject ID.

  - ### Method Detail

    - #### previousState

          public ClusterState previousState()

      Returns:
        Previous cluster state.

    - #### state

          public ClusterState state()

      Returns:
        New cluster state.

    - #### subjectId

          @Nullable
          public @Nullable UUID subjectId()

      Gets security subject ID initiated state change.
      Returns:
        Subject ID if security is enabled, otherwise null.
      See Also:
        `IgniteSecurity.enabled()`